//=============================================================
//DEPENDENCIES
var express = require('express');
var request = require('request');
var servidorExpress = express();
var twitter = require('./conf/api_twitter.conf');
var server_conf = require('./conf/server.conf');
//=============================================================



//=============================================================
//CONVERTING TO TWITTER_CODE
var code = `${twitter.consumer_key}:${twitter.consumer_secret}`;
//var code_base64 = window.btoa(code);
var buffer = new Buffer(code);
var code_base64 = buffer.toString('base64');
var twitter_code = `Basic ${code_base64}`;
//=============================================================



//=============================================================
servidorExpress.use(express.static('../public'));
//=============================================================



//=============================================================
servidorExpress.listen(server_conf.PORT,function(){

  console.log(`Servidor escoltant en el port ${server_conf.PORT} \n Per accedir a l'aplicació web, entrar a localhost:${server_conf.PORT} en un navegador`);


});
//=============================================================



//=============================================================
servidorExpress.get('/api/twitter/getToken',function(req, res){
	var options = {
		method: 'POST',
		url: 'https://api.twitter.com/oauth2/token',
	  	gzip: true, //Peticions request sense comprimir. Si està comprimit apareixen simbols raros
	  		headers:{
	    	'content-length': '29',
	    	'accept-encoding': 'gzip',
	    	'content-type': 'application/json',
	    	'user-agent': 'streamcool',
	     	'authorization': twitter_code
	    	}, //final headers

		 	form:{

		 		grant_type: 'client_credentials'

		 	}
	 	};

	request(options, function (error, response, body) {
		var msgJSON;
		var sendJSON;
		msgJSON = JSON.parse(body);

		if(response.statusCode==200){
			console.log('Login exitos');
			console.log(msgJSON.access_token);
			sendJSON = `{"twitter_token": "bearer ${msgJSON.access_token}"}`;
		}else{
			sendJSON = `{"twitter_token": "undefined"}`;
			console.log('Login ha fallat');
		}

		res.send(JSON.parse(sendJSON));
		res.end();

	});

});
//=============================================================



//=============================================================
servidorExpress.get('/api/twitter/hashtag/:hashtag', function(req, res){
	var theHashtag = req.params.hashtag;//Extrau el parametre hashtag de la url
	var twitter_token = req.headers.twitter_token;//Extrau el camp twitter_token de la capçalera de la peiticio d'un client
	theHashtag = `#${theHashtag}`;
	var options = {
		method: 'GET',
		gzip: true,
  		url: 'https://api.twitter.com/1.1/search/tweets.json',
  		qs: { q: theHashtag, result_type: 'recent', include_entities: '0' },
  		headers: { 
     		'authorization': twitter_token
     	}
    };

	request(options, function (error, response, body) {
  		if (error) throw new Error(error);

  		res.send(JSON.parse(body));
  		res.end();
	});

});
//=============================================================
