$(document).ready(function(){
	//=================================================================
	//INICIAR PROGRAMA
	main();

	//=================================================================



	//=================================================================
	//TEST & DEBUG
	console.log(getNumberFollowers());
	console.log(getLastFollower());
	//=================================================================
	


	//=================================================================
	//INICIALITZACIÓ DE VARIABLES
	var overlay = {//CONFIGURACIÓ OVERLAY PREDETERMINADA. ES PODRIA IMPLEMENTAR UNA CONSULTA JSON
		"customized": false,
		"text":{
			"position":{
				"x": 1118,
				"y": 633
			},
			"properties":{
				"fontSize": "24px",
				"fontFamily": "Gill Sans",
				"fontColor": "#4f4f4f",
				"lineWidth": 100,
				"lineSeparation": 20
			}
		},
		"image": {
			"src": "../img/follow_alert.png",
			"width": 640,
			"height": 360
		}
	};
	
	var canvas = document.getElementById("canvas");
	var ctx = canvas.getContext("2d");
	var followerOverlay = new Overlay(overlay,ctx);
	console.log(followerOverlay);
	//=================================================================



	//=================================================================
	//FUNCIÓ DE INICIALITZACIÓ DEL PROGRAMA
	function main(){
		$("#canvas").hide();//Amaga el canvas. Quan hi haga nou seguidor --> fadeIn
		checkUpdate();
	}
	//=================================================================



	//=================================================================
	//COMPROVAR CADA 3s EL NUM DE SEGUIDORS
	/*
	Si hi ha nous seguidors, crida a la funció showAlert
	*/
	function checkUpdate(){
		var lastFollowerInit = getLastFollower();
		var nFollowersInit = getNumberFollowers();
		var intervalo = setInterval(function(){
			var lastFollower = getLastFollower();
			var nFollowers = getNumberFollowers();
			if(lastFollowerInit != lastFollower && nFollowersInit < nFollowers){//Algú ha fet Follow
				nFollowersInit = nFollowers;
				lastFollowerInit = lastFollower;

				setTimeout(function(){showAlert();},1500);//Sespera un poc ja que a voltes sactualitza uns segons abans el numero de seguidors que la llista de seguidors

			}

			
			if(nFollowersInit > nFollowers){//Algú ha fet Unfollow
				console.log('Algú ha fet Unfollow');
				nFollowersInit = getNumberFollowers();
			}
			
		}, 3000);

	}
	//=================================================================



	//=================================================================
	//MOSTRAR ALERTA
	function showAlert(){
		followerOverlay.refreshOverlay(getLastFollower(),function(){
			$('#canvas').fadeIn('slow');//Mostra el canvas followAlert
		});
		
		setTimeout(function() {
    		$('#canvas').fadeOut('fast');//Amaga el canvas followAlert
		}, 11000);
	}
	//=================================================================

});