//=================================================================
/*CLASSE OVERLAY.js
Esta classe s'encarrega de dibuixar un canvas a part d'un json que
es passa en la variable obj
*/
//=================================================================



//=================================================================
//CLASSE OVERLAY
function Overlay(obj,canvasContext){

	//=================================================================
	//CONSTRUCTOR
	var that = this;//Referenciar funcions i variables al objecte overlay. (Es com una classe)
	that.ctx = canvasContext;
	that.overlay = obj;
	var img = new Image();
	img.src = obj.image.src;
	//=================================================================


	//=================================================================
	//ESCRIU UN TEXT
	function setText(text) {
		that.ctx.save();
		that.ctx.font = `${that.overlay.text.properties.fontSize} ${that.overlay.text.properties.fontFamily}`;
		that.ctx.fillStyle = that.overlay.text.properties.fontColor;
		//that.ctx.fillText(text,that.overlay.text.position.x,that.overlay.text.position.y);
		adaptText(that.ctx, text, that.overlay.text.position.x, that.overlay.text.position.y, that.overlay.text.properties.lineWidth, that.overlay.text.properties.lineSeparation)
		that.ctx.restore();
	}
	//=================================================================



	//=================================================================
	//PINTA UN RENTANGLE VERD QUE OCUPA TOT EL CANVAS
	function setBackground (){
		that.ctx.save();
		that.ctx.fillStyle = "green";
		that.ctx.fillRect(0, 0, 1280, 720);
		that.ctx.save();
	}
	//=================================================================



	//=================================================================
	//FUNCIÓ QUE ADAPTA EL TEXT A PARTIR D'UNA AMPLARIA MAXIMA
	function adaptText(context, text, posX, posY, maxLineWidth, lineSeparation){
		var arrayOfWords = text.split(' ');//array de paraules. (Cada espai determina una paraula split(' '))
		console.log("Array of words: "+arrayOfWords);
		var textLine = '';//Inicialitzem
		var lineWidth;//Variable que guarda el tamany actual en que ocupa el text acumulat (width)
		for(var i = 0; i<arrayOfWords.length; i++){//Recorrem el array de paraules
			textLine = textLine + arrayOfWords[i] + ' ';//Anem acumulant les paraules
			var getPropertiesMeasures = context.measureText(textLine);//Agafem la propietat de mesura del text
			lineWidth = getPropertiesMeasures.width;//Mesurem el que ocupa el text acumulat actual

			if(maxLineWidth<lineWidth || arrayOfWords[i]=="{<br>}"){//Si el tamany que ocupa el text acumulat actual es major que el tamany maxim escriure linia
				if(arrayOfWords[i]!="{<br>}"){
					context.fillText(textLine+' ',posX,posY);
					console.log('escric una linia');
					textLine = '';//Resetegem el text acumulat
				
				}else{

					textLine = textLine.substring(0,textLine.search('{<br>}'));
					console.log("ACABE DE DETECTAR UN BR");
					context.fillText(textLine+' ',posX,posY);
					console.log('escric una linia');
					textLine = '';//Resetegem el text acumulat
				}
				posY = posY + lineSeparation;//Incrementem y per a que la següent linia sescriga baix de l'anterior
			}


			
		}
		if(textLine.length!=0){
			console.log('Acabe en les paraules sobrants')
			context.fillText(textLine,posX,posY);
		}

	}
	//=================================================================



	//=================================================================
	//AFEGIX UNA CAPA DE COLOR VERD I REESCRIU LA IMATGE I EL TEXT
	this.refreshOverlay = function(text,callback){
		/*
		var img = new Image();
		img.src = overlay.image.src;
		*/
		var img = new Image();
		img.src = obj.image.src;
		img.onload = function(){//quan la imatge estiga carregà del src dibuixar
			setBackground();
			that.ctx.drawImage(img,0,0);
			setText(text);
			callback();//Esperem a que es carregue la imatge i despres cridem una funció anònima que fara el fadein
			/*
			refreshOverlay("El tweet", function(){fadeIn})
			*/
		}
	}
	//=================================================================
}
//FI DE LA CLASSE OVERLAY
//=================================================================