//=============================================================================
//
//DETECTAR SI EL USUARI ESTÀ LOGGEJAT
//ACCEDIR A LA INFORMACIÓ DE L'USUARI
//
//=============================================================================



//=============================================================================
//CONFIGURAR I INDICAR AL MODUL L'APLICACIO (ID)
const twitch_api_id = 'kdidolwhf4d0ti6rw33eprscgc8tf5';//Modificar
//=============================================================================



//=============================================================================
//EXTRAU DEL LOCALSTORAGE EL PARAMTERE ACCES_TOKEN
/*
Es contempla l'opció que el token no estiga aguardat en localstorage ja
que quan el OPEN BROADCASTER carregue la pagina no pot accedir al localstorage 
de chrome. La solució es incluir el token en la url en OBS--> /PAGINA_EN_OBS#=token
*/

var tokenCache = localStorage['access_token'];

if(tokenCache){

  tokenCache = localStorage['access_token'];

}else{
  tokenCache = `OAuth ${getValueOfUrl("twitch_access_token")}`;
}
//=============================================================================



//=============================================================================
//RETORNA EL TOKEN
function getToken(){

	var token = localStorage['access_token'];
	var indexMin = token.indexOf(' ')+1;
  var indexMax = token.length;
  token = token.substring(indexMin, indexMax);
	return token;

}
//=============================================================================



//=============================================================================
//OBTINDRE EL NOM D'USUARI
function getUser(){

	var usuari = undefined;
	var URI = 'https://api.twitch.tv/kraken/user' ;

	$.ajax({
  		url: URI,
  		async: false,
  		dataType: 'json',
      headers :{
        'Accept' : 'application/vnd.twitchtv.v5+json',
        'Client-ID' : twitch_api_id,
        'Authorization': tokenCache    
      },
  		success: function (resultat) {
    		usuari = resultat.name;
  		}
	});
  console.log(`Hola ${usuari}`);
	return usuari;

}
//=============================================================================



//=============================================================================
//OBTINDRE LA ID DE USUARI
function getUserId(){

  var usuariId = undefined;
  var URI = 'https://api.twitch.tv/kraken/user' ;

  $.ajax({
      url: URI,
      async: false,
      dataType: 'json',
      headers :{
        'Accept' : 'application/vnd.twitchtv.v5+json',
        'Client-ID' : twitch_api_id,
        'Authorization': tokenCache    
      },
      success: function (resultat) {
        usuariId = resultat._id;
      }
  });
  console.log(`Hola id: ${usuariId}`);
  return usuariId;

}
//=============================================================================



//=============================================================================
//COMPROVA SI EL USUARI ESTA LOGGEJAT (Boolean)
/*
Si está loggejat --> True
Si no està loggejat --> False
*/
function userIsLogged(){

	var logged;
	var URI = 'https://api.twitch.tv/kraken/' ;

	$.ajax({
  		url: URI,
  		async: false,
  		dataType: 'json',
      headers :{
        'Accept' : 'application/vnd.twitchtv.v5+json',
        'Client-ID' : twitch_api_id,
        'Authorization': tokenCache     
      },
  		success: function (resultat) {
    		logged = resultat.token.valid;
  		}
	});

	return logged;	
}
//=============================================================================



//=============================================================================
//Retorna la url de la imatge de perfil del usuari loggejat en la API
function getUserProfile(){

  var urlImage;
  var url = 'https://api.twitch.tv/kraken/user';

  $.ajax({
    url: url,
    async: false,
    dataType: 'json',
    headers :{
      'Accept' : 'application/vnd.twitchtv.v5+json',
      'Client-ID' : twitch_api_id,
      'Authorization': tokenCache     
    },
    success: function (resultat) {
      urlImage = resultat.logo;
    }
  });

  return urlImage;

}
//=============================================================================



//=================================================================
//TORNA EL NUMERO DE SEGUIDORS DEL USUARI LOGGEJAT
function getNumberFollowers(){

  var elResultat;
  var userId = getUserId();
  var URI = `https://api.twitch.tv/kraken/channels/${userId}/follows?channel=${userId}&direction=desc&limit=1`;
  console.log(URI);

  $.ajax({
      url: URI,
      async: false,
      dataType: 'json',
      headers :{
        'Accept' : 'application/vnd.twitchtv.v5+json',
        'Client-ID' : twitch_api_id,
        'Authorization': tokenCache    
      },
      success: function (resultat) {
        elResultat = resultat;
      }

  });

  return elResultat._total;

}
//=================================================================



//=================================================================
//TORNA EL SEGUIDOR MES NOU DE L'USUARI LOGGEJAT
function getLastFollower(){

  var elResultat;
  var userId = getUserId();
  var URI = `https://api.twitch.tv/kraken/channels/${userId}/follows?channel=${userId}&direction=desc&limit=1`;
  console.log(URI);

  $.ajax({
      url: URI,
      async: false,
      dataType: 'json',
      headers :{
        'Accept' : 'application/vnd.twitchtv.v5+json',
        'Client-ID' : twitch_api_id,
        'Authorization': tokenCache    
      },
      success: function (resultat) {
        elResultat = resultat;
      }

  });

  return elResultat.follows[0].user.name;

}
//=================================================================



//=================================================================
//TORNA EL SEGUIDOR MES NOU DE L'USUARI LOGGEJAT
function getListOfFollowers(n){
  var elResultat;
  var userId = getUserId();
  var URI = `https://api.twitch.tv/kraken/channels/${userId}/follows?channel=${userId}&direction=desc&limit=${n}`;
  console.log(URI);
  var followerList = [];

  $.ajax({
      url: URI,
      async: false,
      dataType: 'json',
      headers :{
        'Accept' : 'application/vnd.twitchtv.v5+json',
        'Client-ID' : twitch_api_id,
        'Authorization': tokenCache    
      },
      success: function (resultat) {
        elResultat = resultat;
        for (var i = 0; i < elResultat.follows.length; i++) {
          followerList.push(elResultat.follows[i].user.name);
        }
      }

  });

  return followerList;

}
//=================================================================



//=============================================================================
//Si el usuari no està logejat redireccionar a index.html
if(!userIsLogged()){

  window.location.replace("./index.html");

}
//=============================================================================
